#ifndef GRADIENTWITHLS_H
#define GRADIENTWITHLS_H

#include "gradientdescent.h"

/**
 * @brief The GradientWithLS class, ylopoiei tin gradient descent method
 * alla me grammiki anazitisi gia kalyteri eyresi tou rythmou mathisis.
 */
class GradientWithLS :public GradientDescent
{
private:
    string lineSearchMethod;
public:
    /**
     * @brief GradientWithLS, synartisi dimiourgias
     * @param p
     */
    GradientWithLS(Problem *p);

    /**
     * @brief setLineSearchMethod, orizei tin methodo grammikis
     * anazitisis. Dexetai duo times: golden gia golden search
     * kai armijo gia armijo line search.
     * @param s
     */
    void    setLineSearchMethod(string s);
    /**
     * @brief getLineSearchMethod, epistrefei tin methodo grammikis
     * anazitisis
     * @return
     */
    string  getLineSearchMethod() const;

    /**
     * @brief fl, boithitiki methodos gia tin line search
     * @param h
     * @return
     */
    double  fl(double h);

    /**
     * @brief armijoSerch, i methodos grammikis anazitisis armijo search
     * @param a
     */
    void    armijoSerch(double &a);

    /**
     * @brief goldenSearch, i methodos grammikis anazitisis golden search
     * @param a
     * @param b
     */
    void    goldenSearch(double &a,double &b);

    /**
     * @brief updateRate, enimerosi tou ruthmou mathisis
     */
    virtual void    updateRate();

};

#endif // GRADIENTWITHLS_H
