#ifndef MLPPROBLEM_H
#define MLPPROBLEM_H

#include  "problem.h"
# include "dataset.h"
class MlpProblem : public Problem
{
private:
    /** weight=> einai oi parametroi tou neuronikou, to dianysma w **/
    Data weight;
    /** data => einai to dataset ekpaideysis **/
    Dataset *data;
public:
    /**
     * @brief MlpProblem, i synartisi dimioyrgias
     * @param n => posa hidden nodes (vari) exo.
     * @param d => to train set
     */
    MlpProblem(int n,Dataset *d);
    /**
     * @brief setWeights => allazei ton pinaka weight se w.
     * @param w
     */
    void    setWeights(Data &w);
    /**
     * @brief funmin => einai to sfalma ekpaideysis gia ta weight = x
     * @param x
     * @return
     */
    double  funmin(Data &x);
    /**
     * @brief gradient => einai i paragogos tis synartisis sfalmatos
     * os pros tis parametrous x.
     * @param x
     * @return
     */
    Data    gradient(Data &x);
    /**
     * @brief sig, einai i sigmoidis synartisi gia eisodo x.
     * @param x
     * @return
     */
    double  sig(double x);
    /**
     * @brief sigder, einai i paragogos tis sigmoeidous gia eisodo x.
     * @param x
     * @return
     */
    double  sigder(double x);
    /**
     * @brief getOutput=> einai i timi tou neuronikou gia to protypo x
     * gia weight = x.
     * @param x
     * @return
     */
    double  getOutput(Data &x);
    /**
     * @brief getDerivative=> einai i paragogos gia to protypo x.
     * @param x
     * @return
     */
    Data    getDerivative(Data &x);
    /**
     * @brief getTrainError=> einai to sfalma ekpaideusis,
     * diladi to sfalma sto train set.
     * @return
     */
    double  getTrainError() ;
    /**
     * @brief getTestError=> einai to sfalma sto test set.
     * @param test
     * @return
     */
    double  getTestError(Dataset *test) ;
    /**
     * @brief getClassTestError => einai to classification sfalma
     * gia to test set.
     * @param test
     * @return
     */
    double  getClassTestError(Dataset *test) ;
    ~MlpProblem();
};

#endif // MLPPROBLEM_H
